'From Squeak3.4beta of ''1 December 2002'' [latest update: #5138] on 15 December 2002 at 6:36:32 pm'!
"Change Set:		Prolog
Date:			13 December 2002
Author:			Mike Teng, Bolot Kerimbaev

Port of Mike Teng's V/Prolog to Squeak.

TODO:
- add more examples from Prolog Tutorial (http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/contents.html)

Dec 13, 2002:
- FIX by Henrik Gedenryd (adds method:context:encoder: method).
- FIX by Hannes Hirzel (adds emptyList method to LParser).
- Added PrologWorkspace for easier Prologing
- FIX by bolot (fixes Dungeons example, from 99/10/29)
- Added smoother animation for Dungeons example

NOTE:
- ContextPart>>singleRelease is modified, potentially may cause issues

References:
http://squeak.cs.uiuc.edu/mail/squeak/msg05140.html
http://lists.squeakfoundation.org/pipermail/squeak-dev/2002-March/035766.html
http://fce.cc.gatech.edu/~bolot/squeak/prolog/Dungeon.991029-1806.st

Squeak specific implementation resides
primarily in the following classes:

LParser
LCompiler (makes LParser its default parser)
Prolog (makes LCompiler its default compiler)

DEMO
PrologWorkspace openDemoFamily

directly invoking the compiler:
LCompiler evaluate: 'Family new :? father(''John'',x)'
"!

Object subclass: #DogStep
	instanceVariableNames: 'destination speed forwardDirection isAbsolute '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Compiler subclass: #LCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Parser subclass: #LParser
	instanceVariableNames: 'prologMethodSelector prologMethodArgument cuts temporaries statements cascadeMessages '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!LParser commentStamp: 'bolot 12/13/2002 15:14' prior: 0!
RE: safeGuardReturnBlock
Makes sure that the method returns, even if no match occurs.

RE: queryUndefined
Disabled for Prolog methods (because undefined Prolog variables are unbounds).

RE: prologMethodSelector
Can be used to determine if this is a smalltalk method or prolog method.

RE: Smalltalk guys
Strings, symbols, numbers, and literal points (45@65) are recognized.

RE: evaluation
Support for nicer, more Prolog-like syntax for evaluation is done through direct use of LCompiler.
Example: LCompiler evaluate: 'Family new :? father(''John'', x).'
(see Family comment for current situation)

This class and other related classes in this category were originally written by or are based on the work by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

Collection subclass: #List
	instanceVariableNames: 'content link '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
List subclass: #EmptyList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Object subclass: #Logic
	instanceVariableNames: 'answer varList unboundVars tempResult returnBlock '
	classVariableNames: 'BinaryOp Database '
	poolDictionaries: ''
	category: 'Prolog'!
Object subclass: #LogicDontCare
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Object subclass: #LogicRef
	instanceVariableNames: 'content '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Object subclass: #LogicUnbound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Logic subclass: #Prolog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!Prolog commentStamp: 'bolot 12/13/2002 15:12' prior: 0!
This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.  We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

Smalltalk renameClassNamed: #DevPrologLists as: #DFAutomata!
Prolog subclass: #DFAutomata
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
Prolog subclass: #Doctor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!Doctor commentStamp: 'bolot 12/13/2002 15:59' prior: 0!
A demo class.

Used by Family>>health:

This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

Prolog subclass: #Dungeon
	instanceVariableNames: 'pen aspect snoopy delay arcs nodes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!Dungeon commentStamp: 'bolot 12/15/2002 18:27' prior: 0!
bolot 12/15/2002 18:26
- Example was fixed 1999/10/29
http://fce.cc.gatech.edu/~bolot/squeak/prolog/Dungeon.991029-1806.st
- this changeset adds slightly smoother animation!

Prolog subclass: #Family
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!Family commentStamp: 'bolot 12/13/2002 15:24' prior: 0!
A demo class
Examples:
LCompiler evaluate: 'Family new :? father(x,y)'
LCompiler evaluate: 'Family new :? grandPa(''John'',y)'

This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

Prolog subclass: #PrologDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologDemo commentStamp: 'bolot 12/14/2002 22:14' prior: 0!
Miscellaneous Prolog snippets!

Workspace subclass: #PrologWorkspace
	instanceVariableNames: 'doItReceiverPrototype '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!PrologWorkspace commentStamp: 'bolot 12/13/2002 15:47' prior: 0!
PrologWorkspace

enables "pure" Prolog syntax to be used, instead of directly invoking LCompiler

try these:

Family new :? father(x,y)
Family new :? grandPa('John',y)
!

List subclass: #Relation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!
PolygonMorph subclass: #WanderingDogMorph
	instanceVariableNames: 'destinations speed stepTime lastDestination '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog'!

!WanderingDogMorph commentStamp: 'bolot 12/15/2002 03:13' prior: 0!
WanderingDogMorph - used for animating Dungeons demo



self openInWorld
self stop
self start
self position: 10@100
self position
self addFlexShellIfNecessary 
self owner position
self position: 10@10
self goto: 300@500
self owner delete
self stepTime: 100
TransformationMorph 
self player
moveToward:
self isFlexed 
self referencePosition bearingToPoint: 10@100
self referencePosition
!


!Collection methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
asList
    | aList pointer |
    aList := EmptyList new.
    self do: [:i |
        aList add: i.
        pointer isNil
            ifTrue: [pointer := aList]
            ifFalse: [pointer := pointer tail]].
    ^aList! !


!ContextPart methodsFor: 'debugger access' stamp: 'bolot 7/9/1999 14:18'!
singleRelease
	"Remove information from the receiver in order to break circularities."

	"stackp == nil ifFalse: [1 to: stackp do: [:i | self at: i put: nil]]."
	sender _ nil! !


!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:19'!
defaultHopSpeed
	^15! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:19'!
defaultSpeed
	^15! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
fall: aHeight
	"relative"
	self fall: aHeight from: 0@0.
	isAbsolute _ false.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
fall: aHeight from: aStartPoint
	"relative"
	destination _ aStartPoint + (0@aHeight).
	speed _ self defaultHopSpeed.
	forwardDirection _ 180.
	isAbsolute _ true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:46'!
getDestination
	^destination! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:45'!
getForwardDirection
	^forwardDirection! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:45'!
getSpeed
	^speed! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:12'!
go: aPoint
	"relative"
	destination _ aPoint.
	speed _ self defaultSpeed.
	forwardDirection _ 90.
	isAbsolute _ false.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:12'!
goto: aPoint
	"absolute"
	destination _ aPoint.
	speed _ self defaultSpeed.
	forwardDirection _ 90.
	isAbsolute _ true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:42'!
goto: aPoint speed: aSpeed
	"absolute"
	destination _ aPoint.
	speed _ aSpeed.
	forwardDirection _ 90.
	isAbsolute _ true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:37'!
isAbsolute
	^isAbsolute == true! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
jump: aHeight
	"relative"
	self jump: aHeight from: 0@0.
	isAbsolute _ false.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
jump: aHeight from: aStartPoint
	"relative"
	destination _ aStartPoint - (0@aHeight).
	speed _ self defaultHopSpeed.
	forwardDirection _ 0.
	isAbsolute _ true.! !


!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
fall: aHeight
	^self new fall: aHeight; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 18:03'!
fall: aHeight from: aStartPoint
	^self new fall: aHeight from: aStartPoint; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:42'!
go: aPoint
	^self new go: aPoint; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
goto: aPoint
	^self new goto: aPoint; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:43'!
goto: aPoint speed: aSpeed
	^self new goto: aPoint speed: aSpeed; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
jump: aHeight
	^self new jump: aHeight; yourself! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 18:03'!
jump: aHeight from: aStartPoint
	^self new jump: aHeight from: aStartPoint; yourself! !


!LCompiler class methodsFor: 'accessing' stamp: 'bolot 7/2/1999 17:25'!
parserClass
	"Return a parser class to use for parsing method headers."

	^LParser! !


!LParser methodsFor: 'expression types' stamp: 'bolot 8/5/1999 19:13'!
messagePart: level repeat: repeat
	"bolot 8/5/1999 18:14"
	"This is the same as Parser>>messagePart:repeat:"
	"with only ONE addition: support for #:? for calling Prolog stuff"

	| start receiver selector args precedence words keywordStart |
	[receiver _ parseNode.
	(hereType == #keyword and: [level >= 3])
		ifTrue: 
			[start _ self startOfNextToken.
			selector _ WriteStream on: (String new: 32).
			args _ OrderedCollection new.
			words _ OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[keywordStart _ self startOfNextToken + requestorOffset.
					selector nextPutAll: self advance.
					words addLast: (keywordStart to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 2 repeat: true.
					args addLast: parseNode].
			(Symbol hasInterned: selector contents ifTrue: [ :sym | selector _ sym])
				ifFalse: [ selector _ self correctSelector: selector contents
										wordIntervals: words
										exprInterval: (start to: self endOfLastToken)
										ifAbort: [ ^ self fail ] ].
			precedence _ 3]
		ifFalse: [((hereType == #binary or: [hereType == #verticalBar])
				and: [level >= 2])
				ifTrue: 
					[start _ self startOfNextToken.
					selector _ self advance asSymbol.
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 1 repeat: true.
					args _ Array with: parseNode.
					precedence _ 2]
				ifFalse: [hereType == #word
						ifTrue: 
							[start _ self startOfNextToken.
							selector _ self advance.
							args _ #().
							words _ OrderedCollection with:
									(start + requestorOffset to: self endOfLastToken + requestorOffset).
							(Symbol hasInterned: selector ifTrue: [ :sym | selector _ sym])
								ifFalse: [ selector _ self correctSelector: selector
													wordIntervals: words
													exprInterval: (start to: self endOfLastToken)
													ifAbort: [ ^ self fail ] ].
							precedence _ 1]
						ifFalse: [(self match: #colonQuestion)
								ifTrue: [selector _ #inferSmalltalk:var:.
										"change typeTable for Prologging"
										typeTable at: $, asciiValue put: #comma;
											at: $!! asciiValue put: #exclamationMark.
										args _ Array with: (self goalSeries) with: (encoder encodeLiteral: #inka).
										"restore typeTable for Smalltalking"
										typeTable at: $, asciiValue put: (TypeTable at: $, asciiValue);
											at: $!! asciiValue put: (TypeTable at: $!! asciiValue).
										precedence _ 3 "TODO: pick right precedence"]
								ifFalse: [^args notNil]]]].
	parseNode _ MessageNode new
				receiver: receiver
				selector: selector
				arguments: args
				precedence: precedence
				from: encoder
				sourceRange: (start to: self endOfLastToken).
	repeat]
		whileTrue: [].
	^true! !

!LParser methodsFor: 'expression types' stamp: 'bolot 8/5/1999 20:31'!
method: doit context: ctxt

	| sap blk prim messageComment methodNode |
	"need temporaries/statements in doits - to enable unbounds"
	temporaries _ OrderedCollection new.
	statements _ OrderedCollection new.
	"may need to change (temporarily) for doits"
	typeTable _ typeTable copy.

	"check if it's a Prolog method definition"
	((doit not and: [hereType == #word]) and: [tokenType == #leftParenthesis])
		ifTrue:
			[^self prologMethod: doit context: ctxt].

	sap _ self pattern: doit inContext: ctxt.
	"sap={selector, arguments, precedence}"
	(sap at: 2) do: [:argNode | argNode isArg: true].
	temporaries _ self temporaries asOrderedCollection.

	messageComment _ currentComment.
	currentComment _ nil.
	prim _ doit ifTrue: [0] ifFalse: [self primitive].
	self statements: #() innerBlock: doit.

	parseNode statements: statements , parseNode statements.

	blk _ parseNode.
	doit ifTrue: [blk returnLast]
		ifFalse: [blk returnSelfIfNoOther].
	hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
	self interactive ifTrue: [self removeUnusedTemps].

	methodNode _ MethodNode new comment: messageComment.
	^methodNode
		selector: (sap at: 1)
		arguments: (sap at: 2)
		precedence: (sap at: 3)
		temporaries: temporaries
		block: blk
		encoder: encoder
		primitive: prim! !

!LParser methodsFor: 'expression types' stamp: 'bolot 12/13/2002 15:20'!
method: doit context: ctxt encoder: encoderToUse

    | sap blk prim messageComment methodNode |
    encoder _ encoderToUse.
    "need temporaries/statements in doits - to enable unbounds"
    temporaries _ OrderedCollection new.
    statements _ OrderedCollection new.
    "may need to change (temporarily) for doits"
    typeTable _ typeTable copy.

    "check if it's a Prolog method definition"
    ((doit not and: [hereType == #word]) and: [tokenType == #leftParenthesis])
        ifTrue:
            [^self prologMethod: doit context: ctxt].

    sap _ self pattern: doit inContext: ctxt.
    "sap={selector, arguments, precedence}"
    (sap at: 2) do: [:argNode | argNode isArg: true].
    temporaries _ self temporaries asOrderedCollection.

    messageComment _ currentComment.
    currentComment _ nil.
    prim _ doit ifTrue: [0] ifFalse: [self primitive].
    self statements: #() innerBlock: doit.

    parseNode statements: statements , parseNode statements.

    blk _ parseNode.
    doit ifTrue: [blk returnLast]
        ifFalse: [blk returnSelfIfNoOther].
    hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
    self interactive ifTrue: [self removeUnusedTemps].

    methodNode _ self newMethodNode comment: messageComment.
    ^methodNode
        selector: (sap at: 1)
        arguments: (sap at: 2)
        precedence: (sap at: 3)
        temporaries: temporaries
        block: blk
        encoder: encoder
        primitive: prim! !

!LParser methodsFor: 'expression types' stamp: 'bolot 8/5/1999 19:16'!
prologMethod: doit context: ctxt

	| blk messageComment methodNode blockComment |
	prologMethodSelector _ (here, ':') asSymbol.
	typeTable at: $, asciiValue put: #comma.
	typeTable at: $!! asciiValue put: #exclamationMark.

	(prologMethodArgument _ encoder bindArg: #assoc) isArg: true.
	messageComment _ currentComment.
	currentComment _ nil.
	" self statements: #() innerBlock: doit. "
	parseNode _ BlockNode new
				arguments: #()
				statements: (self ruleSeries, self safeGuardReturnStatements)
				returns: doit
				from: encoder.
	blockComment _ currentComment.
	currentComment _ nil.
	parseNode comment: blockComment.
	blk _ parseNode.
	hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
	methodNode _ MethodNode new comment: messageComment.
	^methodNode
		selector: prologMethodSelector
		arguments: (OrderedCollection with: prologMethodArgument)
		precedence: 3
		temporaries: temporaries
		block: blk
		encoder: encoder
		primitive: 0! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 22:15'!
addTemp: aTerm
	"Decide whether aTerm should be
	declared as a temporay."
	| var |

	var _ encoder encodeVariable: aTerm asString
		ifUnknown: [encoder bindTemp: aTerm asString].

	(#('true' 'false' 'nil' 'super' 'self') includes:
		aTerm asString) ifTrue: [^var].
	(aTerm asString at: 1) isLowercase ifFalse: [^var].
	temporaries do: [:i |
		i = aTerm ifTrue: [^var]].
	temporaries add: aTerm.
	statements addFirst: (
		AssignmentNode new
			variable: var
			value: (self send: #new
					to: 'LogicRef'
					with: #())).
	^var! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 16:58'!
argumentList: aList
	^(aList isKindOf: List)
		ifTrue: [self arguments: aList]
		ifFalse: [aList]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/4/1999 18:14'!
arguments: aList
	"Answer a MessageNode for predicate
	arguments."
	| receiver bList |
	aList isEmpty  "zero argument"
		ifTrue: [^self nilList].
	receiver _
		self send: #with:
			to: ((aList isKindOf: Relation)
				ifTrue: ['Relation']
				ifFalse: ['List'])
			with: (Array with:
				(self argumentList: aList head)).
	aList isLastNode  "single argument or [x | y]"
		ifTrue: [
			aList tail = self nilList
				ifTrue: [^receiver]
				ifFalse: [
					receiver _
						self sendCascade: #addList:
							to: receiver
							with: (Array with:
								(self argumentList: aList tail)).
					^self send: #yourself
						to: receiver
						with: #()]].
	"more than one arguments"
	bList _ aList tail.
	[receiver _
		self sendCascade: #add:
			to: receiver
			with: (Array with:
				(self argumentList: bList head)).
	bList _ bList tail.
 	(bList isKindOf: List)
		ifTrue: [bList isEmpty]
		ifFalse: [receiver _
			self sendCascade: #addList:
				to: receiver
				with: (Array with:
					(self argumentList: bList)).
			true]]
	whileFalse: [].
	^self send: #yourself
		to: receiver
		with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/4/1999 02:02'!
buildBlock
	(self match: #colonDash)
		ifTrue: [^self predicateSeries]
		ifFalse: [^self send: #value to: prologMethodArgument with: #()]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 12/13/2002 16:16'!
emptyList
	^self send: #new to: 'EmptyList' with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 19:09'!
goalSeries
	"Do the work for method statements by
	 adding each goal to statements."
	" (Prolog new :? goal1(x,y), goal2(z,y)) do: [:i | ...] "
	| aList expression |
	aList _ List new.
	[expression _ self predicate.
	aList add: expression.
	(self match: #comma)]
		whileTrue: [].
	^self goalSeries: aList! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 19:09'!
goalSeries: aList
	"Do the work for method statements by
	 adding each goal to statements."
	"Return a MessageNode"
	" (Prolog new :? goal1(x,y), goal2(z,y)) do: [:i | ...] "

	| receiver bList |
	aList isEmpty  "zero argument"
		ifTrue: [^self nilList].
	receiver _
		self send: #with:
			to: ((aList isKindOf: Relation)
				ifTrue: ['Relation']
				ifFalse: ['List'])
			with: (Array with:
				(self goalSeriesList: aList head)).
	aList isLastNode  "single argument or [x | y]"
		ifTrue: [
			aList tail = self nilList
				ifTrue: [^receiver]
				ifFalse: [
					receiver _
						self sendCascade: #addList:
							to: receiver
							with: (Array with:
								(self goalSeriesList: aList tail)).
					^self send: #yourself
						to: receiver
						with: #()]].
	"more than one arguments"
	bList _ aList tail.
	[receiver _
		self sendCascade: #add:
			to: receiver
			with: (Array with:
				(self goalSeriesList: bList head)).
	bList _ bList tail.
 	(bList isKindOf: List)
		ifTrue: [bList isEmpty]
		ifFalse: [receiver _
			self sendCascade: #addList:
				to: receiver
				with: (Array with:
					(self goalSeriesList: bList)).
			true]]
	whileFalse: [].
	^self send: #yourself
		to: receiver
		with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 19:06'!
goalSeriesList: aList
	^(aList isKindOf: List)
		ifTrue: [self goalSeries: aList]
		ifFalse: [aList]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 17:04'!
listTerms
	"Answer a list of predicate terms."
	| term aList |
	self advance.
	(self match: #rightBracket)
		ifTrue: [
			^self emptyList].
	term _ self term.
	aList _ List with: term.
	[true] whileTrue: [
		(self match: #verticalBar)
			ifTrue: [
				aList addList: self term.
				(self match: #rightBracket)
					ifTrue: [
						^aList]
					ifFalse: [self expected: 'Right bracket']].
	(self match: #comma)
		ifTrue: [aList add: self term]
		ifFalse: [
			(self match: #rightBracket)
				ifTrue: [^aList]
				ifFalse: [self expected: 'Right bracket']]]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 21:22'!
nilList
	^self send: #new to: 'EmptyList' with: #()! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:43'!
predCut
	cuts _ 1.
	^List with: #cut: with: (self returnBlock: (encoder encodeVariable: 'self'))

	"^List with:
		(SelectorNode new
			position: token position;
			value: #cut:)
		with:
			(self returnBlock:
			(VariableNode new
				value: 'self'))"! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/5/1999 17:12'!
predSmalltalk: result
	"Process predicate with a Prolog
	and a Smalltalk term."
	| expression |
	result add: (self term).
	(self match: #comma)
		ifFalse: [self expected: 'Term (comma?)'].
	self expression
		ifFalse: [self expected: 'Expression'].
	expression _ parseNode.
    (self match: #rightParenthesis)
		ifFalse: [self expected: 'Right parenthesis'].
	result add:
		(BlockNode new
			arguments: #()
			statements: (OrderedCollection with: expression)
			returns: false
			from: encoder).! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:36'!
predicate
	| result pred |
	(((hereType == #period) or: [
	hereType == #comma]) or: [hereType == #doIt])
		ifTrue: [self expected: 'Predicate'].
	(self match: #exclamationMark)
		ifTrue: [^self predCut].
	hereType == #word
		ifFalse: [self notify: 'illegal predicate name'].
	pred _ here asString.
	"intercept special cases, or:/and: are macros"
	(#('or' 'and') includes: pred)
		ifTrue: [pred _ pred asUppercase].
	result _ Relation with: (pred, ':') asSymbol.
	self advance.
	" must be '(' or binary predicate "
	(self match: #leftParenthesis)
		ifFalse: [self expected: 'Left parenthesis for predicate'].
	(pred = 'is' or: [pred = 'consult'])
		ifTrue: [self predSmalltalk: result] "special cases"
		ifFalse: [
			(self match: #rightParenthesis)
				ifFalse: [
					self terms: result.
					(self match: #rightParenthesis)
						ifFalse: [self expected: 'Right parenthesis']]].
	^result! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 22:01'!
predicateSeries
	| pred |
	pred _ self predicate.
    ^BlockNode new
		arguments: OrderedCollection new
		statements: (OrderedCollection with: (
			self
				send: pred head
				to: 'self'
				with: (Array with: (self send: #key:value:
						to: 'Association'
						with: (Array
							with: (self arguments: pred tail)
							with:
								((self match: #comma)
									ifTrue: [self predicateSeries]
									ifFalse:[self
										send: #value
										to: prologMethodArgument
										with: #()]))))))
		returns: false
		from: encoder! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:11'!
returnBlock: anExpression
	"Answer a Block which returns anExpression."

	^BlockNode new
		arguments: #()
		statements: (OrderedCollection with:
			(ReturnNode new
				expr: anExpression
				encoder: encoder
				sourceRange: (1 to: 1)))
		returns: true
		from: encoder! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 18:45'!
rule
	"rule:
		predicate [:- predicates] "
	| predicate headArg block |
	cuts _ nil.
	predicate _ self predicate.
	predicate head == prologMethodSelector
		ifFalse: [self notify: 'predicate name different'].
	headArg _ self arguments: predicate tail.
	block _ self buildBlock.
	(self match: #period)
		ifFalse: [self expected: 'Period'].
	(hereType == #doIt and: [cuts isNil])
		ifTrue: [ "optimize the stack"
			^self send: #unify:with:then:
				to: 'self'
				with: (OrderedCollection
					with: (self send: #key to: prologMethodArgument with: #())
					with: headArg
					with: (self returnBlock: block))]
		ifFalse: [
			^self send: #unify:with:then:
				to: 'self'
				with: (OrderedCollection
					with: (self send: 'key' to: prologMethodArgument with: #())
					with: headArg
					with: block)]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 18:31'!
ruleSeries
	"Do the work for method statements by
	 adding each rule to statements."
	| expression |
	[expression _ self rule.
	statements add: expression.
	source atEnd]
		whileFalse: [].
	^statements! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 14:23'!
safeGuardReturnStatements
	^OrderedCollection
		with: (self send: #ifTrue:ifFalse: to: (self send: #isEmptyOrNil to: 'answer' with: #())
				with: (Array with: (self returnBlock: (encoder encodeVariable: 'nil'))
						with: (self returnBlock: (self send: #asArray to: 'answer' with: #()))))
	"self unbindVar: 0.
	answer isEmptyOrNil
		ifTrue: [^nil]
		ifFalse: [^answer asArray]"

	"answer ifNil: [^nil].
	answer size = 0 ifTrue: [^nil].
	^answer asArray"! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:10'!
send: selector to: receiver with: arguments
	"selector is a Symbol or a Selector
	node. receiver can be
	either a String or other nodes."
	| receiverNode argNodes |
	receiverNode _  (receiver isKindOf: String)
						ifTrue: [encoder encodeVariable: receiver]
						ifFalse: [receiver].

	argNodes _ arguments collect: [:elem |
		(elem isKindOf: ParseNode)
			ifTrue: [elem]
			ifFalse: [encoder encodeLiteral: elem]].

	(cascadeMessages isNil or: [(cascadeMessages includesKey: receiver) not])
		ifTrue: [^MessageNode new
				receiver: receiverNode
				selector: (selector asSymbol)
				arguments: argNodes
				precedence: 3
				from: encoder
				sourceRange: (1 to: 1)]
		ifFalse: [(cascadeMessages at: receiver)
					add: (MessageNode new
					receiver: nil
					selector: (selector asSymbol)
					arguments: argNodes
					precedence: 3
					from: encoder
					sourceRange: (1 to: 1)).
				^CascadeNode new
				receiver: receiverNode
				messages: (cascadeMessages removeKey: receiver)]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:10'!
sendCascade: selector to: receiver with: arguments
	"selector is a Symbol. receiver is a Node."
	| argNodes cascadeReceiver |

	cascadeMessages isNil
		ifTrue: [cascadeMessages _ Dictionary new].
	(cascadeMessages includesKey: receiver)
		ifFalse: [cascadeMessages at: receiver put: OrderedCollection new].

	argNodes _ arguments collect: [:elem |
		(elem isKindOf: ParseNode)
			ifTrue: [elem]
			ifFalse: [encoder encodeLiteral: elem]].

	(cascadeMessages at: receiver)
		add: (cascadeReceiver _ MessageNode new receiver: nil
				selector: selector
				arguments: argNodes
				precedence: 3
				from: encoder
				sourceRange: (1 to: 1)).
	^receiver! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 19:15'!
structure: aSymbol
	"Process the argument part of a structure
	 whose functor is aSymbol. Current token
	 is now the left paren. Answer a Relation
	 representing the structure."
	| result |
	result _ Relation with: aSymbol.
	"self advance."
	(self match: #rightParenthesis)
		ifFalse: [
			self terms: result.
			(self match: #rightParenthesis)
				ifFalse: [self expected: 'Right parenthesis']].
	^result! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 8/14/1999 15:24'!
term
	| result |
	((hereType == #rightParenthesis) or: [hereType == #comma])
		ifTrue: [self expected: 'Term'].
	(hereType == #leftBracket)
		ifTrue: [^self listTerms].
	(self match: #leftParenthesis)
		ifTrue: [^self structure: #and].
	result _ here.
	(hereType == #number and: [token == #@])
		ifTrue:
			[self advance; advance.
			result _ result @ here.
			self advance.
			^result].
	(hereType == #string or: [hereType == #number or: [hereType == #literal]])
		ifTrue: 
			[self advance.
			^result].
	hereType == #word
		ifFalse: [
			(self match: #leftArrow) "should be #underscore"
				ifTrue: [^self send: #new to: 'LogicDontCare' with: #()]
				ifFalse: [self notify: 'illegal term']].
	self advance.
	(self match: #leftParenthesis)
		ifTrue: [^self structure: result asSymbol]
		ifFalse: [^self addTemp: result]! !

!LParser methodsFor: 'prolog parser' stamp: 'bolot 7/28/1999 22:01'!
terms: aList
        "Answer a list of predicate terms."
    | term |
    term _ self term.
    aList add: term.
    (self match: #comma)
        ifTrue: [self terms: aList]! !

!LParser methodsFor: 'error correction' stamp: 'bolot 8/4/1999 18:24'!
queryUndefined
	"a lot of Prolog variables are undefined because they are unbound"
	"let's prevent unnecessary interrogation (unless it's a Smalltalk method)"
	prologMethodSelector ifNil: [^super queryUndefined]! !

!LParser methodsFor: 'multi-character scans' stamp: 'bolot 7/6/1999 21:39'!
xColon		"process prolog :- and :? symbols"
	aheadChar = $- ifTrue:
		[self step.
		tokenType _ #colonDash.
		self step.
		^ token _ #colonDash].
	aheadChar = $? ifTrue:
		[self step.
		tokenType _ #colonQuestion.
		self step.
		^ token _ #colonQuestion].
	^super xColon! !


!List methodsFor: 'testing' stamp: 'mt 6/30/1999 12:00'!
isEmpty
    ^false! !

!List methodsFor: 'testing' stamp: 'bolot 8/4/1999 18:04'!
isLastNode
        "Answer true if receiver's link contains
         an EmptyList."
    ^link class == EmptyList or: [(link isKindOf: List) not]! !

!List methodsFor: 'adding' stamp: 'mt 6/30/1999 12:00'!
add: anObject
    link class == EmptyList
        ifTrue: [
            link := List with: anObject]
        ifFalse: [
            (link isKindOf: List)
                ifTrue: [link add: anObject]
                ifFalse: [self error: 'can''t add to non-list']].
    ^anObject! !

!List methodsFor: 'adding' stamp: 'mt 6/30/1999 12:00'!
addList: aList
    link class == EmptyList
        ifTrue: [
            link := aList]
        ifFalse: [
            (link isKindOf: List)
                ifTrue: [link addList: aList]
                ifFalse: [self error: 'can''t add to non-list']].
    ^aList! !

!List methodsFor: 'enumerating' stamp: 'mt 6/30/1999 12:00'!
do: aBlock
        "Answer the receiver.  For each element in the receiver,
         evaluate aBlock with that element as the argument."
    | aNode |
    aNode := self.
    [aBlock value: aNode head.
     aNode := aNode tail.
     (aNode isKindOf: List) ifFalse: [^self].
     aNode isEmpty]
        whileFalse: []! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
at: anInteger
        "Answer the element at the position anInteger."
    | answer |
    anInteger < 1
        ifTrue: [self error: 'index less than 1'].
    anInteger = 1
        ifTrue: [^content]
        ifFalse: [
            self isLastNode
                ifFalse: [^link at: anInteger - 1]
                ifTrue: [self error: 'out of range']]! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
head
    ^content! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
head: anObject
    content := anObject! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
size
    ^1 +
        ((link isKindOf: List)
            ifTrue: [link size]
            ifFalse: [0])! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
tail
    ^link! !

!List methodsFor: 'accessing' stamp: 'mt 6/30/1999 12:00'!
tail: anObject
    link := anObject! !

!List methodsFor: 'printing' stamp: 'mt 6/30/1999 12:00'!
printOn: aStream
    aStream nextPut: $[.
    self printOne: aStream.
    aStream nextPut: $]! !

!List methodsFor: 'printing' stamp: 'mt 6/30/1999 12:00'!
printOne: aStream
    content printOn: aStream.
    aStream nextPut: $ .
    (link isKindOf: List)
        ifTrue: [link printOne: aStream]
        ifFalse: [
            aStream nextPutAll: '| '.
            link printOn: aStream]! !


!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^anObject class == EmptyList! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
add: anObject
    | aList |
    aList := List with: anObject.
    aList become: self.
    ^aList! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
do: aBlock
    ^self! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
head
        "Error, empty list does not have head."
    ^self error: 'Message not understood: head'! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
isEmpty
    ^true! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOne: aStream
        "Print nothing."! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
size
    ^0! !

!EmptyList methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
tail
        "Error, empty list does not have tail."
    ^self error: 'Message not understood: tail'! !


!List class methodsFor: 'instance creation' stamp: 'bolot 7/28/1999 15:31'!
fromBraceStack: itsSize 
	"Answer an instance of me with itsSize elements, popped in reverse order from
	 the stack of thisContext sender.  Do not call directly: this is called by {1. 2. 3}
	 constructs."

	^((Array new: itsSize) fill: itsSize fromStack: thisContext sender) asList! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
head: aObject tail: bObject
    ^self basicNew
        head: aObject;
        tail: bObject;
        yourself! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^EmptyList new! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
with: anObject
    ^self basicNew
        head: anObject;
        tail: EmptyList new! !

!List class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
with: anObject with: bObject
    ^self basicNew
        head: anObject;
        tail: (List with: bObject)! !


!EmptyList class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
new
    ^self basicNew! !


!Logic methodsFor: 'query' stamp: 'mt 6/28/1999 12:00'!
buildQuery: aList
        "Private"
    | pred block |
    pred := aList head.
    self addVarFrom: pred tail.
    block :=
        (aList tail isEmpty
            ifTrue: [[self inferAnswer]]
            ifFalse: [self buildQuery: aList tail]).
    ^[self perform: pred head with:
        (Association
            key: pred tail
            value: block)]! !

!Logic methodsFor: 'query' stamp: 'bolot 7/12/1999 19:03'!
doGoal: aRelation continue: aBlock
	"Try to satisfy aRelation as a goal."
	| blk mark |
	mark := unboundVars size.
	((aRelation isKindOf: List) and: [
	aRelation head class == Symbol])
		ifFalse: [self error: 'not a goal'].
	blk := self
		perform: (aRelation head, ':') asSymbol
		with: (Association
			key: aRelation tail
			value: aBlock).
	[blk class == BlockContext]
		whileTrue: [blk := blk value].
	self unbindVar: mark! !

!Logic methodsFor: 'query' stamp: 'bolot 7/12/1999 19:02'!
doOneGoal: aRelation
	"Try to satisfy aRelation as a goal.
	 Answer true if success, else false."
	| blk mark |
	mark := unboundVars size.
	((aRelation isKindOf: List) and: [
	aRelation head class == Symbol])
		ifFalse: [self error: 'not a goal'].
	blk := self
		perform: (aRelation head, ':') asSymbol
		with: (Association
			key: aRelation tail
			value: [^true]).
	[blk class == BlockContext]
		whileTrue: [blk := blk value].
	self unbindVar: mark.
	^false! !

!Logic methodsFor: 'query' stamp: 'mt 6/28/1999 12:00'!
match: x with: y
        "Private -- Answer true if x matches y, else
         answer false."
    | xLast yLast |
 "Transcript nextPutAll: x printString;nextPut: $ ;
 nextPutAll: y printString;cr."
    (x class == LogicDontCare or: [y class == LogicDontCare])
         ifTrue: [^true].
    (x class == LogicRef)
        ifTrue: [
            xLast := x lastNode.
            xLast value class == LogicUnbound
                ifTrue: [
                    unboundVars add: xLast.
                    xLast value: y.
                    ^true]
                ifFalse: [xLast := xLast value]]
        ifFalse: [xLast := x].
    (y class == LogicRef)
        ifTrue: [
            yLast := y lastNode.
            yLast value class == LogicUnbound
                ifTrue: [
                    unboundVars add: yLast.
                    yLast value: x.
                    ^true]
                ifFalse: [
                    yLast := yLast value]]
        ifFalse: [yLast := y].
    (xLast class == List) ifTrue: [
        (yLast class == List)
            ifTrue: [
                (self match: xLast head with: yLast head)
                    ifTrue: [^self
                        match: xLast tail
                        with: yLast tail]]
            ifFalse: [^false]].
    (xLast class == Relation) ifTrue: [
        (yLast class == Relation)
            ifTrue: [
                (self match: xLast head with: yLast head)
                    ifTrue: [^self
                        match: xLast tail
                        with: yLast tail]]
            ifFalse: [^false]].
    ^xLast = yLast! !

!Logic methodsFor: 'query' stamp: 'mt 6/28/1999 12:00'!
retrieve: assoc from: dataList
        "Retrieve a fact in assoc from
         Database entry dataList."
    | aList |
    dataList isEmpty ifTrue: [^self].
    aList := dataList.
    [aList isLastNode] whileFalse: [
        self unify: assoc key
            with: aList head
            then: assoc value.
        aList := aList tail].
    self unify: assoc key
        with: aList head
        then: [^assoc value]! !

!Logic methodsFor: 'query' stamp: 'bolot 7/28/1999 23:09'!
unify: x with: y then: aBlock
        "Private -- If x unifies with y, then execute
         aBlock. Answer self."
    | mark |
"Transcript show: x printString, ' ', y printString; cr."
    mark := unboundVars size.
    (self match: x with: y)
        ifTrue:
            [tempResult := aBlock.
             [(tempResult := tempResult value).
              tempResult class == BlockContext]
                whileTrue: []].
    self unbindVar: mark! !

!Logic methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
addVarFrom: aList
    aList isEmpty ifTrue: [^self].
    (aList head isKindOf: List)
        ifTrue: [self addVarFrom: aList head]
        ifFalse: [
            ((aList head class == LogicRef and:
            [aList head value class == LogicUnbound]) and:
            [(varList includes: aList head) not])
                ifTrue: [varList add: aList head]].
    self addVarFrom: aList tail! !

!Logic methodsFor: 'accessing' stamp: 'programmatic 6/30/1999 19:05'!
allValue: aLogicRef
        "Copy all the values to an instance
         the same class as the content of aLogicRef.
         If aLogicRef's content is a List, walk
         through all elements."
    | anAnswer aList |
    (aLogicRef isKindOf: LogicRef)
        ifTrue: [anAnswer := aLogicRef value]
        ifFalse: [anAnswer := aLogicRef].
    (anAnswer isKindOf: List)
        ifTrue: [
            anAnswer isEmpty ifTrue: [^anAnswer].
            aList := anAnswer.
            anAnswer := anAnswer class with:
                (self allValue: aList head).
            anAnswer tail: (self allValue: aList tail)].
    ^anAnswer! !

!Logic methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
doesNotUnderstand: aMessage
    | temp |
    temp := aMessage selector.
    temp := (temp copyFrom: 1 to: temp size - 1)
        asSymbol.
    temp := Database at: temp ifAbsent: [
        ^self error: 'Message not understood: ', aMessage selector
        ].
    ^self retrieve: (aMessage arguments at: 1)
        from: temp! !

!Logic methodsFor: 'accessing' stamp: 'bolot 7/7/1999 19:52'!
structureHead: aSymbol arguments: anInteger
        "Answer a structure whose functor is
         aSymbol and arguments are anInteger
         number of DontCares."
    | aRelation |
    aRelation := Relation with: aSymbol.
    anInteger timesRepeat: [
        aRelation add: LogicDontCare new].
    ^aRelation! !

!Logic methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
value: aRef
        "Private -- Answer the value of the
         logic ref, aRef."
    aRef class == LogicRef
        ifTrue: [^aRef value]
        ifFalse: [^aRef]! !

!Logic methodsFor: 'private' stamp: 'programmatic 6/30/1999 19:04'!
first: assoc
        "Private -- Answer the first argument."
    | anAnswer |
    anAnswer := assoc key head.
    ^self value: anAnswer! !

!Logic methodsFor: 'private' stamp: 'bolot 8/1/1999 12:42'!
inferAnswer
        "Private -- Add an Array of values to
         the answer collection."
    | anArray i |
    anArray := Array new: varList size.
    i := 1.
    varList do: [:x |
        anArray at: i put: (self allValue: x).
        i := i + 1].
    answer add: anArray.! !

!Logic methodsFor: 'private' stamp: 'bolot 7/22/1999 16:23'!
inferSmalltalk: aList var: bList
        "Private -- Handle query from Smalltalk. aList
         contains a list of predicates and
         bList is a list of unbound variables."
    | blk |
    varList := List new.
    answer := OrderedCollection new.
    returnBlock := [
        self unbindVar: 0.
        answer size = 0
            ifTrue: [^nil]
            ifFalse: [^answer asArray]].
    blk := self buildQuery: aList.
    [(blk := blk value) class == BlockContext]
        whileTrue: [].
    ^returnBlock value! !

!Logic methodsFor: 'private' stamp: 'programmatic 6/30/1999 19:05'!
second: assoc
        "Private -- Answer the second argument."
    | anAnswer |
    anAnswer := assoc key tail head.
    ^self value: anAnswer! !

!Logic methodsFor: 'private' stamp: 'mt 6/28/1999 12:00'!
unbindVar: mark
        "Private -- Unbind previously bound variables
         down to mark."
    | index |
    [(index := unboundVars size) > mark]
        whileTrue: [
            (unboundVars at: index)
                content: LogicUnbound new.
            unboundVars removeLast]! !

!Logic methodsFor: 'initialization' stamp: 'mt 6/28/1999 12:00'!
initialize
        "Private -- Initialize instance variables."
    unboundVars := OrderedCollection new: 2000! !


!Logic class methodsFor: 'initialize-release' stamp: 'mt 6/28/1999 12:00'!
initialize
        "Initialize Database."
    Database := Dictionary new! !

!Logic class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super new initialize! !

!Logic class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
database
    ^Database! !


!LogicDontCare methodsFor: 'parser support' stamp: 'bolot 7/19/1999 17:55'!
size
	" symbol used for LogicDontCare is '_' (underscore) "
	^self printString size! !

!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^true! !

!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    aStream nextPutAll: '_';
        nextPut: $ ! !


!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^self value = anObject! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
== anObject
    ^self value == anObject! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
at: anObject
    ^self value at: anObject! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content
    ^content! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content: anObject
    content := anObject! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
doesNotUnderstand: aMessage
    ^self value
        perform: aMessage selector
        withArguments: aMessage arguments! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
lastNode
    | aNode |
    aNode := self.
    [aNode content class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    self value printOn: aStream! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
value
    | aNode |
    aNode := content.
    [aNode class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
value: anObject
    | node |
    node := self lastNode.
    anObject class == LogicRef
        ifTrue: [
            node == anObject lastNode
                ifFalse: [node content: anObject]]
        ifFalse: [
            node content: anObject]! !


!LogicRef class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
new
    ^super new value: LogicUnbound new! !


!LogicUnbound methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    'Unbound' printOn: aStream! !


!Prolog methodsFor: 'complex goals' stamp: 'bolot 8/1/1999 12:39'!
AND: assoc
    "Try to satisfy a list of goals."
    | aList |
    aList := assoc key.
    [aList isEmpty] whileFalse: [
        (self doOneGoal: aList head)
            ifTrue: [aList := aList tail]
            ifFalse: [^self]].
    ^assoc value! !

!Prolog methodsFor: 'complex goals' stamp: 'bolot 8/1/1999 12:40'!
OR: assoc
    "Disjunction predicate."
    assoc key size = 2 ifFalse: [^self].
    self doGoal: (self first: assoc) continue: assoc value.
    self doGoal: (self second: assoc) continue: assoc value! !

!Prolog methodsFor: 'complex goals' stamp: 'mt 6/28/1999 12:00'!
and: assoc
    "Try to satisfy a list of goals."
    | aList |
    aList := assoc key.
    [aList isEmpty] whileFalse: [
        (self doOneGoal: aList head)
            ifTrue: [aList := aList tail]
            ifFalse: [^self]].
    ^assoc value! !

!Prolog methodsFor: 'complex goals' stamp: 'mt 6/28/1999 12:00'!
call: assoc
        "Execute the argument as a predicate."
    | blk |
    assoc key size = 1 ifFalse: [^self].
    blk := self first: assoc.
    ((blk isKindOf: List) and: [
    blk head class == Symbol])
        ifFalse: [self error: 'not a goal'].
    ^[self perform: (blk head, ':') asSymbol
            with: (Association key: blk tail
                value: assoc value)]! !

!Prolog methodsFor: 'complex goals' stamp: 'bolot 7/6/1999 23:31'!
not: assoc
        "Succeed if the evaluation of the argument
         as a goal fails."
    | blk |
    assoc key size = 1 ifFalse: [^self].
    blk := self first: assoc.
    (blk isKindOf: List)
        ifFalse: [self error: 'argument must be goal'].
    blk :=
        self perform: (blk head , ':') asSymbol
            with:
                (Association key: blk tail
                    value: [^self]).
    [blk class == BlockContext] "value until real success"
        whileTrue: [blk := blk value].
    ^assoc value! !

!Prolog methodsFor: 'complex goals' stamp: 'mt 6/28/1999 12:00'!
or: assoc
    "Disjunction predicate."
    assoc key size = 2 ifFalse: [^self].
    self doGoal: (self first: assoc) continue: assoc value.
    self doGoal: (self second: assoc) continue: assoc value! !

!Prolog methodsFor: 'complex goals' stamp: 'mt 6/28/1999 12:00'!
repeat: assoc
        "Succeed always, even
         during backtacking."
    | blk mark |
    assoc key size = 0 ifFalse: [^self].
    mark := unboundVars size.
    [true] whileTrue: [
        blk := assoc value.
        [(blk := blk value) class == BlockContext]
            whileTrue: [].
        self unbindVar: mark]! !

!Prolog methodsFor: 'database' stamp: 'mt 6/28/1999 12:00'!
asserta: assoc
        "Add the fact in assoc to the
         beginning of the database."
    | arg aList |
    assoc key size = 1 ifFalse: [^self].
    arg := self allValue: (self first: assoc).
    aList := Database at: arg head ifAbsent: [^self].
    Database at: arg head put:
        (List head: arg tail tail: aList).
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'mt 6/28/1999 12:00'!
assertz: assoc
        "Add the fact in assoc to the
         end of the database."
    | arg aList |
    assoc key size = 1 ifFalse: [^self].
    arg := self allValue: (self first: assoc).
    aList := Database at: arg head ifAbsent: [^self].
    aList add: arg tail.
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'mt 6/28/1999 12:00'!
database: assoc
        "Create a database which can hold facts
         being asserted or extracted. The argument
         must be a structure."
    | arg functor source |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    ((arg isKindOf: Relation) and:
    [arg head isKindOf: Symbol])
        ifFalse: [self error: 'argument is not a fact'].
    functor := (arg head, ':') asSymbol.
    Database at: arg head ifAbsent: [
        Database at: arg head put: List new].
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'mt 6/28/1999 12:00'!
purgeDatabase: assoc
        "Purge a database identified by the
         structure in the argument."
    | arg |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    ((arg isKindOf: Relation) and:
    [arg head isKindOf: Symbol])
        ifFalse: [self error: 'argument is not a fact'].
    Database at: arg head ifAbsent: [^self].
    Database removeKey: arg head.
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'mt 6/28/1999 12:00'!
retract: assoc
        "Delete the first fact unified with the
         one in assoc from the database. Delete
         the next one during backtrack."
    | arg aList bList |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    [aList := Database at: arg head ifAbsent: [^self].
     aList isEmpty ifTrue: [^self].
     self unify: arg tail
        with: aList head
        then: [Database at: arg head put: aList tail.
               assoc value value].
     aList == (Database at: arg head)]
        whileFalse: [].
    [(bList := aList tail) isEmpty] whileFalse: [
        self unify: arg tail
            with: aList tail head
            then: [aList tail: aList tail tail.
                   bList := aList.
                   assoc value value].
        aList := bList.
        aList isEmpty ifTrue: [^self]]! !

!Prolog methodsFor: 'classifying terms' stamp: 'mt 6/28/1999 12:00'!
atom: assoc
        "Succeed if the argument is a Symbol."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) class == Symbol
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'mt 6/28/1999 12:00'!
atomic: assoc
        "Succeed if the argument is a Symbol
         or an integer."
    | arg |
    assoc key size = 1 ifFalse: [^self].
    ((arg := self first: assoc) class == Symbol
    or: [arg isKindOf: Integer])
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'mt 6/28/1999 12:00'!
integer: assoc
        "Succeed if the argument is an Integer."
    assoc key size = 1 ifFalse: [^self].
    ((self first: assoc) isKindOf: Integer)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'mt 6/28/1999 12:00'!
nonvar: assoc
        "Succeed if the argument is not an
         unbound variable."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) class == LogicUnbound
        ifFalse: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'mt 6/28/1999 12:00'!
var: assoc
        "Succeed if the argument is an
         unbound variable."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) class == LogicUnbound
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'mt 6/28/1999 12:00'!
consult: assoc
        "Ask the second argument as the receiver
         (a Smalltalk expression) to solve the goals
         contained in the first argument, e.g.
            consult(father(x, 'John'), family new)."
    | blk |
    assoc key size = 2 ifFalse: [^self].
    blk := self first: assoc.
    blk class == Relation
        ifFalse: [self error: 'first argument must be predicate'].
    ^[(self second: assoc) value
        perform: (blk head, ':') asSymbol
        with: (Association key: blk tail
               value: assoc value)]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'mt 6/28/1999 12:00'!
is: assoc
        "Execute the second argument as a Smalltalk
         expression and then unify its result with
         the first argument."
    assoc key size = 2 ifFalse: [^self].
    self unify: assoc key head
        with: (self value: assoc key tail head) value
        then: [^assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'mt 6/28/1999 12:00'!
runtime: assoc
        "Unify the first argument with
         the system time in milliseconds."
    assoc key size = 1 ifFalse: [^self].
    self unify: assoc key head
        with: Time millisecondClockValue
        then: [^assoc value]! !

!Prolog methodsFor: 'backtracking' stamp: 'bolot 7/12/1999 19:25'!
cut: assoc 
	" Succeed always, exit the containing method
	  during backtacking."
	| blk mark |
	assoc key size = 1 ifFalse: [^ self].
	mark _ unboundVars size.
	blk _ assoc value.
	[(blk _ blk value) class == BlockContext] whileTrue.
	self unbindVar: mark.
	assoc key head value! !

!Prolog methodsFor: 'backtracking' stamp: 'bolot 7/12/1999 19:25'!
exit: assoc
	" exit Prolog "
	| blk |
	blk _ assoc value.
	[(blk _ blk value) class == BlockContext] whileTrue.
	^returnBlock value! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
eq: assoc
        "Succeed if the two arguments can be unified."
    assoc key size = 2 ifFalse: [^self].
    self unify: assoc key head
        with: assoc key tail head
        then: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
equiv: assoc
        "Succeed if the two arguments are the same object."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) == (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
ge: assoc
        "Succeed if the first argument is
         greater than or equal to the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) >= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
gt: assoc
        "Succeed if the first argument is
         greater than the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) > (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
le: assoc
        "Succeed if the first argument is
         less than or equal to the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) <= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
lt: assoc
        "Succeed if the first argument is
         less than the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) < (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
ne: assoc
        "Succeed if the first argument is
         greater than the second."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) ~= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'mt 6/28/1999 12:00'!
notEquiv: assoc
        "Succeed if the two arguments
         are not the same object."
    assoc key size = 2 ifFalse: [^self].
    (self first: assoc) == (self second: assoc)
        ifFalse: [^assoc value]! !

!Prolog methodsFor: 'success-failure' stamp: 'mt 6/28/1999 12:00'!
fail: assoc
        "Fail always."! !

!Prolog methodsFor: 'success-failure' stamp: 'mt 6/28/1999 12:00'!
true: assoc
        "Succeed always."
    assoc key size = 0 ifFalse: [^self].
    ^assoc value! !

!Prolog methodsFor: 'debugging' stamp: 'mt 6/28/1999 12:00'!
halt: assoc
        "Halt the execution.  Smalltalk debugger
         can be invoked at this point."
    assoc key size = 0 ifFalse: [^self].
    self halt! !

!Prolog methodsFor: 'input-output' stamp: 'mt 6/28/1999 12:00'!
nl: assoc
        "Write an end of line to
         Transcript."
    assoc key size = 0 ifFalse: [^self].
    Transcript cr.
    ^assoc value! !

!Prolog methodsFor: 'input-output' stamp: 'programmatic 6/30/1999 19:07'!
read: assoc
        "Read a Smalltalk expression, evaluate it and
         answer the result.  This can be used to input
         a Symbol, a number, a quoted string, etc."
    | anAnswer |
    assoc key size = 1 ifFalse: [^self].
    anAnswer := FillInTheBlank
		request: 'type a line and return'
		initialAnswer: ''.
    self unify: assoc key head
        with: anAnswer
        then: [^assoc value]! !

!Prolog methodsFor: 'input-output' stamp: 'bolot 12/15/2002 01:04'!
write: assoc
        "Write all the arguments to Transcript."
    | value |
    assoc key do: [:argument |
        value := self allValue: argument.
        Transcript show:
            ((value isKindOf: String)
                ifTrue: [value]
                ifFalse: [value printString])].
    ^assoc value! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/12/1999 19:22'!
acceptsLoggingOfCompilation
	^true! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/7/1999 20:15'!
compilerClass
	^LCompiler! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 8/5/1999 16:21'!
evaluatorClass
	"Answer an evaluator class appropriate for evaluating expressions in the 
	context of this class."

	^LCompiler! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/6/1999 22:17'!
sourceCodeTemplate
	"Answer an expression to be edited and evaluated in order to define 
	methods in this class."

    ^'"comment"
predicate(term1, term2) :-
    goal1(term3),
    goal2(term4).'! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/12/1999 19:22'!
wantsChangeSetLogging
	^true! !

!Prolog methodsFor: 'structures' stamp: 'bolot 8/4/1999 00:52'!
arg(n, structure, x) :-
	integer(n),
	is(true, structure value isKindOf: List),
	is(x, (self allValue: structure)
		at: n + 1).! !

!Prolog methodsFor: 'structures' stamp: 'bolot 8/4/1999 00:57'!
functor(structure, head, arguments) :-
	var(structure),
	atom(head),
	integer(arguments),
	is(structure, self
		structureHead: head
		arguments: arguments).
	"The first argument can be either a
	Relation or a List whose first
	element is a Symbol."
functor([sHead, sTail], head, arguments) :-
	atom(sHead),
	eq(head, sHead),
	is(arguments, sTail value size).! !

!Prolog methodsFor: 'structures' stamp: 'bolot 8/4/1999 00:58'!
univ(structure, list) :-
	nonvar(structure),
	is(true, structure value class == Relation),
	is(x, self allValue: structure),
	is(list, List
		head: x value head
		tail: x value tail).
univ(structure, [head, list]) :-
	atom(head),
	is(x, self allValue: list),
	is(structure, Relation
		head: head value
		tail: x value).! !


!DFAutomata methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 16:24'!
parse(L) :- start(S), 
	trans(S,L).! !

!DFAutomata methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 16:16'!
trans(X,[A|B]) :- 
      delta(X,A,Y),   
      write(X),
      write('  '),
      write([A|B]),
      nl(),
      trans(Y,B).  
trans(X,[]) :- 
      final(X),
      write(X),
      write('  '),
      write([]), nl().
! !


!Doctor methodsFor: 'as yet unclassified' stamp: 'bolot 8/4/1999 15:35'!
healthHistory('John', 'John had two times of heart attacks').
healthHistory('Mary', 'Mary had no serious problems').! !


!Dungeon methodsFor: 'dungeons' stamp: 'bolot 8/14/1999 14:45'!
"Adjust the y coordinate by Aspect ratio."
adjust(result, y) :-
    is(result, (y value * aspect) truncated).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 10/29/1999 17:23'!
"Fail if room is one of roomsToAvoid and
 go back to previousRoom. Else succeed."
avoid(room,roomsToAvoid,previousRoom) :-
	member(room,roomsToAvoid),
	goto(previousRoom), !!, fail().
avoid(_,_,_).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 8/14/1999 14:45'!
"Draw a map of the dungeon."
draw() :- drawArc(), fail().
draw() :- drawNode(), fail().
draw(). ! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 10/29/1999 17:57'!
"Draw the path between two rooms."
drawArc() :- gallery(x, y),
	position(x, a, b),
	position(y, c, d),
	is(_, arcs add: (PolygonMorph vertices: {a value @ b value. c value @ d value}
			color: Color black borderWidth: 2 borderColor: Color black)),
	is(_, World addMorph: arcs last behind: snoopy).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 12/15/2002 18:36'!
"Call a Smalltalk method to draw a room."
drawNode() :-
	position(x, a, b),
	"is(_, x value displayAt: a value @ b value),"
	is(_, nodes add: (SimpleButtonMorph new label: x value)),
	is(_, nodes last position: a value-20 @ (b value-10)),
	is(_, World addMorph: nodes last behind: snoopy).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 12/15/2002 18:34'!
end: arg
	"End the whole thing.  This method
	does not return.  It restarts the Scheduler."
	3 timesRepeat: [snoopy hop: 100].
	snoopy go: 100@0.
	snoopy go: -200@0.
	snoopy go: 100@0.
	PopUpMenu notify: 'Click OK when animation is over'.
	snoopy delete.
	snoopy _ nil.
	arcs , nodes do: [:morph | morph delete].
	arcs _ nodes _ nil.
	Display restore.
	'The End' halt: 'Gold is found, close this window'.
	"Scheduler resume"! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 8/14/1999 14:44'!
"Define database of all connecting rooms."
gallery(#entry,#monsters).
gallery(#entry,#stadium).
gallery(#stadium,#hell).
gallery(#stadium,#dolphin).
gallery(#stadium,#pond).
gallery(#exit,#gold).
gallery(#robbers,#gold).
gallery(#stadium,#robbers).
gallery(#pond,#gold).
gallery(#dolphin,#exit).
gallery(#monsters,#gold).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 10/29/1999 16:56'!
"Move from a room here to a room there."
go() :-
	initialize(),
	draw(),
	"is(_, self halt),"
	route(#entry,#exit,[#entry]).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 12/15/2002 17:17'!
"Move the animal to nextRoom."
goto(nextRoom) :-
	position(nextRoom, x, y),
	is(_, snoopy goto: x value @ (y value)).
	"is(_, snoopy position: x value - 30 @ (y value - 25)),"
	"is(_, Transcript show: '')," "to force morphs to appear"
	"is(_, delay wait)."! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 12/15/2002 17:24'!
initialize: arg
	"This is a Smalltalk method, but can be called as
	a Prolog/V predicate.  It initializes instance
	variables and gray the screen"

	snoopy _ WanderingDogMorph newSnoopyDog.
	snoopy openInWorld.
	arcs _ OrderedCollection new.
	nodes _ OrderedCollection new.
	"delay _ Delay forSeconds: 1."
	"pen _ PenPointRecorder new defaultNib: 2."
	aspect _ 1.
	^arg value! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 10/29/1999 18:04'!
"Check if adventure is succeeded."
isFinished(visitedRooms) :-
	member(#gold,visitedRooms),
	end().
isFinished([_, x | _]) :-
	goto(x), !!, fail().! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 8/14/1999 14:44'!
"Succeed if the first argument is a
 member of a List in the second argument."
member(x,[x | _]).
member(x,[_ | h]) :- member (x,h).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 8/14/1999 15:46'!
"Unify the next neighbor room of x with y."
neighborroom(x,y,visitedRooms) :-
	OR(gallery(x,y), gallery(y,x)).
neighborroom(_,_,[_ , x | _]) :-
	goto(x), !!, fail().! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 8/14/1999 14:49'!
"Define the position of each room on screen."
position(#entry,40,y) :- adjust(y, 80).
position(#stadium,230,y) :- adjust(y, 50).
position(#monsters,40,y) :- adjust(y, 200).
position(#hell,90,y) :- adjust(y, 310).
position(#pond,330,y) :- adjust(y, 160).
position(#gold,460,y) :- adjust(y, 200).
position(#dolphin,380,y) :- adjust(y, 70).
position(#robbers,230,y) :- adjust(y, 310).
position(#exit,580,y) :- adjust(y, 180).! !

!Dungeon methodsFor: 'dungeons' stamp: 'bolot 10/29/1999 17:25'!
"Find the route to the next room avoiding
 dangerous or visited rooms."
route(#exit,#exit,visitedRooms) :-
	isFinished(visitedRooms).
route(#exit,_,_).
route(room,wayOut,visitedRooms) :-
	not(eq(room, #exit)),
	neighborroom(room,nextRoom,visitedRooms),
	not(member(nextRoom,visitedRooms)),
	goto(nextRoom),
	avoid(nextRoom,[#monsters, #robbers],room),
	route(nextRoom,wayOut,[nextRoom|visitedRooms]).! !


!Family methodsFor: 'demo' stamp: 'bolot 8/14/1999 14:24'!
father('John', 'Mary').  "John is the father of Mary"
father('John', 'David').
father('David', 'Jack').
father('Arthur', 'Nancy').! !

!Family methodsFor: 'demo' stamp: 'bolot 8/14/1999 15:36'!
"x is the grandPa of y."
grandPa(x, y) :-
	father(x, z),
	or(father(z, y),mother(z,y)).! !

!Family methodsFor: 'demo' stamp: 'bolot 8/14/1999 14:24'!
"Return the health history of x."
health(x, history) :-
	consult( healthHistory(x, history), Doctor new).! !

!Family methodsFor: 'demo' stamp: 'bolot 8/14/1999 14:23'!
"Mary is the mother of Nancy."
mother('Mary', 'Nancy').! !

!Family methodsFor: 'demo' stamp: 'bolot 8/14/1999 15:36'!
parent(x,y) :-
	or(father(x,y), mother(x,y)).! !

!Dungeon class methodsFor: 'instance creation' stamp: 'bolot 10/24/1999 22:20'!
dogShapeVertices
	"this is a large dog, use (array/4) rounded to get a smaller one"
	^{195@30. 237@44. 230@61. 200@56. 212@72. 188@63. 171@101. 184@162. 150@111. 120@172. 126@107. 46@110. 56@165. 30@124. 0@159. 18@64. 7@4. 35@48. 141@51. 170@18. 173@0. 181@11. 195@2. 195@30}! !


!PrologDemo methodsFor: 'as yet unclassified' stamp: 'bolot 12/14/2002 22:15'!
factorial(x, y) :- is(y, x value factorial).! !

!PrologDemo methodsFor: 'as yet unclassified' stamp: 'bolot 12/14/2002 22:14'!
member(x,[x|_]).
member(x,[_|r]) :- member(x,r).! !


!PrologWorkspace methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:46'!
doItReceiver
	^doItReceiverPrototype ifNil: [doItReceiverPrototype _ Prolog new]! !


!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:58'!
demoFamilyString
	^
'Family new :? father(x,y)
Family new :? grandPa(''John'',y)'! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:32'!
demoString
	^
'"Dungeon example"
Dungeon new :? go()

"Family demo"
Family new :? father(x,y)
Family new :? grandPa(''John'',y)
Family new :? father(''John'',z)

Family new :? health(x, y)

"databases"
Family new :? database(brother())
Family new :? assertz(brother(''John'', ''Stewart'')),
	asserta(brother(''John'', ''Barbara'')), assertz(brother(''John'', ''Alan'')).
Family new :? brother(x,y)
Family new :? retract(brother(''John'', ''Stewart''))
Prolog database inspect
Family new :? purgeDatabase(brother())

"input/output"
Prolog new :? read(x)

"combining Squeak and Prolog"
(Family new :? father(''John'', x))
do: [ :eachAnswer |
	Transcript show: (eachAnswer at: 1), '' is a child of John''; cr]

"various examples"
PrologDemo new :? member(''a'',[''a'', ''b'', ''c''])
PrologDemo new :? factorial(7,fac)

PrologDemo new :? eq(''a'', ''B'')
PrologDemo new :? eq(''a'', ''a'')

Resources:

Prolog Tutorial
http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/contents.html
'! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:45'!
open
	self openLabel: 'Prolog Workspace'! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/14/2002 23:00'!
openDemo
	"self openDemo"
	(self new contents: self demoString) openLabel: 'Prolog Workspace'! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 16:09'!
openDemoFamily
	"self openDemoFamily"
	(self new contents: self demoFamilyString) openLabel: 'Prolog Workspace'! !


!Relation methodsFor: 'adding' stamp: 'mt 6/28/1999 12:00'!
add: anObject
    (content isNil and: [link isNil])
        ifTrue: [
            content := anObject.
            link := EmptyList new]
        ifFalse: [super add: anObject].
    ^anObject! !

!Relation methodsFor: 'printing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    content printOn: aStream.
    aStream nextPut: $(.
    (link isKindOf: List)
        ifTrue: [link printOne: aStream]
        ifFalse: [link printOn: aStream].
    aStream nextPut: $)! !


!Relation class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super basicNew! !


!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:33'!
addDestination: aPoint
	destinations add: aPoint.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 03:23'!
delete
	| currOwner |
	self isFlexed
		ifTrue: [currOwner _ self owner. super delete. currOwner delete]
		ifFalse: [super delete].! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:05'!
fall: aHeight
	| lastStep |
	lastStep _ destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep fall: aHeight from: lastStep getDestination)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:33'!
getSpeed
	^speed! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:18'!
go: aPoint
	| lastStep |
	lastStep _ destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep goto: aPoint + lastStep getDestination)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:42'!
goto: aPoint
"Transcript show: 'going to: ', aPoint asString; cr."
	self addDestination: (DogStep goto: aPoint)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:43'!
goto: aPoint speed: aNumber
"Transcript show: 'going to: ', aPoint asString; cr."
	self addDestination: (DogStep goto: aPoint speed: aNumber)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:50'!
hop: aHeight
	self jump: aHeight.
	self fall: aHeight.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:48'!
initialize
	super initialize.
	destinations _ OrderedCollection new.
	Player new costume: self.
	speed _ 5.
	lastDestination _ DogStep goto: self position.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:04'!
jump: aHeight
	| lastStep |
	lastStep _ destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep jump: aHeight from: lastStep getDestination)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:12'!
setSpeed: aNumber
	speed _ aNumber! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:20'!
step
	| nextPoint nextStep angle alterEgo |
	super step.
	destinations isEmptyOrNil ifTrue: [^self].
	nextStep _ destinations first.
	self setSpeed: nextStep getSpeed.
	nextPoint _ nextStep getDestination.
	nextStep isAbsolute ifFalse: [nextPoint _ nextPoint + lastDestination getDestination].
	"nextStep getForwardDirection = self forwardDirection
		ifFalse: [self forwardDirection: nextStep getForwardDirection]."

	self isFlexed ifTrue: [alterEgo _ self owner] ifFalse: [alterEgo _ self].
	"alterEgo _ self owner."

	((alterEgo referencePosition - nextPoint) r < (2*self getSpeed))
		ifTrue: [lastDestination _ destinations removeFirst].
	angle _ alterEgo referencePosition bearingToPoint: nextPoint.
	self player setHeading: angle.
	self player forward: self getSpeed.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:47'!
stop
	super stop.
	destinations _ OrderedCollection new! !


!WanderingDogMorph class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:00'!
dogShapeVertices
	"this is a large dog, use (array/4) rounded to get a smaller one"
	^{195@30. 237@44. 230@61. 200@56. 212@72. 188@63. 171@101. 184@162. 150@111. 120@172. 126@107. 46@110. 56@165. 30@124. 0@159. 18@64. 7@4. 35@48. 141@51. 170@18. 173@0. 181@11. 195@2. 195@30}! !

!WanderingDogMorph class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:24'!
newSnoopyDog
	^self new
		vertices: (self dogShapeVertices / 4) rounded
			color: Color white
			borderWidth: 2 borderColor: Color black;
		makeClosed;
		setSpeed: 10;
		forwardDirection: 90;
		yourself! !

WanderingDogMorph class removeSelector: #snoopyDog!
WanderingDogMorph removeSelector: #stepTime!
Dungeon class removeSelector: #snoopyDog!
DFAutomata removeSelector: #member:!
Logic initialize!
DogStep removeSelector: #hop:!
