'From Squeak3.10.1 of ''26 May 2008'' [latest update: #7175] on 8 June 2008 at 12:32:36 am'!

!Logic methodsFor: 'query' stamp: 'spfa 6/7/2008 23:58'!
doGoal: aRelation continue: aBlock
	"Try to satisfy aRelation as a goal."
	| blk mark |
	mark := unboundVars size.
	((aRelation isKindOf: List) and: [
	aRelation head isSymbol])
		ifFalse: [self error: 'not a goal'].
	blk := self
		perform: (aRelation head, ':') asSymbol
		with: (Association
			key: aRelation tail
			value: aBlock).
	[blk class == BlockContext]
		whileTrue: [blk := blk value].
	self unbindVar: mark! !

!Logic methodsFor: 'query' stamp: 'spfa 6/7/2008 23:59'!
doOneGoal: aRelation
	"Try to satisfy aRelation as a goal.
	 Answer true if success, else false."
	| blk mark |
	mark := unboundVars size.
	((aRelation isKindOf: List) and: [
	aRelation head isSymbol])
		ifFalse: [self error: 'not a goal'].
	blk := self
		perform: (aRelation head, ':') asSymbol
		with: (Association
			key: aRelation tail
			value: [^true]).
	[blk class == BlockContext]
		whileTrue: [blk := blk value].
	self unbindVar: mark.
	^false! !


!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/8/2008 00:00'!
call: assoc
        "Execute the argument as a predicate."
    | blk |
    assoc key size = 1 ifFalse: [^self].
    blk := self first: assoc.
    ((blk isKindOf: List) and: [
    blk head isSymbol])
        ifFalse: [self error: 'not a goal'].
    ^[self perform: (blk head, ':') asSymbol
            with: (Association key: blk tail
                value: assoc value)]! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/8/2008 00:00'!
database: assoc
        "Create a database which can hold facts
         being asserted or extracted. The argument
         must be a structure."
    | arg functor source |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    ((arg isKindOf: Relation) and:
    [arg head isSymbol])
        ifFalse: [self error: 'argument is not a fact'].
    functor := (arg head, ':') asSymbol.
    Database at: arg head ifAbsent: [
        Database at: arg head put: List new].
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/8/2008 00:01'!
purgeDatabase: assoc
        "Purge a database identified by the
         structure in the argument."
    | arg |
    assoc key size = 1 ifFalse: [^self].
    arg := self first: assoc.
    ((arg isKindOf: Relation) and:
    [arg head isSymbol])
        ifFalse: [self error: 'argument is not a fact'].
    Database at: arg head ifAbsent: [^self].
    Database removeKey: arg head.
    ^assoc value! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 00:00'!
atom: assoc
        "Succeed if the argument is a Symbol."
    assoc key size = 1 ifFalse: [^self].
    (self first: assoc) isSymbol
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/8/2008 00:00'!
atomic: assoc
        "Succeed if the argument is a Symbol
         or an integer."
    | arg |
    assoc key size = 1 ifFalse: [^self].
    ((arg := self first: assoc) isSymbol
    or: [arg isKindOf: Integer])
        ifTrue: [^assoc value]! !

